# AUTOGENERATED! DO NOT EDIT! File to edit: 00_graphtools.ipynb (unless otherwise specified).

__all__ = ['non_pendant_edges', 'is_pendant', 'has_isolated_nodes']

# Cell
def non_pendant_edges(G):
    "Returns all non pendant edges of a graph `G`"
    edges = list(G.edges())
    edges = [edge for edge in edges if not is_pendant(G, edge)]
    return edges

def is_pendant(G, edge):
    "Checks if `edge` is pendant in the graph `G`"
    if G.degree(edge[0]) == 1 or G.degree(edge[1]) == 1:
        return True
    else:
        return False

def has_isolated_nodes(G):
    "Checks if the graph `G` has isolated nodes"
    if len(list(nx.isolates(G))) > 0:
        return True
    else:
        return False